/**
 *
 */
package de.intevation.gnv.state;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import de.intevation.artifactdatabase.Config;
import de.intevation.artifacts.CallContext;
import de.intevation.gnv.state.exception.StateException;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class PreSettingsTransferState extends DefaultState {

    /**
     * The UID of this Class
     */
    private static final long serialVersionUID = 573381812690806922L;

    private String transferPreSettingsName = null;
    
    private String transferInputDataname = null;
    /**
     * Constructor
     */
    public PreSettingsTransferState() {
        super();
    }

    /**
     * @see de.intevation.gnv.state.StateBase#initialize(java.lang.String, de.intevation.artifacts.CallContext)
     */
    @Override
    public void initialize(String uuid, CallContext context)
                                                            throws StateException {
        Map<String, InputData> preSettings = this.getPreSettings();
        if (preSettings != null){
            InputData ip = preSettings.get(transferPreSettingsName);
            if (ip != null){
                Collection<InputData> localInputdata = new ArrayList<InputData>(1);
                localInputdata.add(new DefaultInputData(transferInputDataname,
                                                        ip.getValue()));
                this.putInputData(localInputdata, uuid);
            }
        }
        
        super.initialize(uuid, context);
    }

    /**
     * @see de.intevation.gnv.state.StateBase#setup(org.w3c.dom.Node)
     */
    @Override
    public void setup(Node configuration) {
        
        Element preSettingsNode = (Element)Config.getNodeXPath(configuration,
                                                         "presettings-transfer");
        if (preSettingsNode != null){
            this.transferPreSettingsName = preSettingsNode.getAttribute("presetting");
            this.transferInputDataname   = preSettingsNode.getAttribute("inputvalue");
        }
        super.setup(configuration);
    }
    
    

}
